-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

---------------------
-- Prep the module --
---------------------
local M = {}
M.type = "auxilliary"
M.relevantDevice = nil
M.defaultOrder = 11000

-----------------
-- Debug stuff --
-----------------
local ugfxCalled = 0

---------------------------------------------
-- Graphics update function                --
-- Updates other stuff too according to dt --
---------------------------------------------
local function updateGFX(dt)
	-- Debug message
	if ugfxCalled == 0 then
		ugfxCalled = 1
		print("SubRollCtrl updateGFX called")
	end
	
	local eSteering = (electrics.values['steering_input'] or 0)
	local rollL = 0
	local rollR = 0
	if eSteering < 0 then
		rollL = (electrics.values['enSubRollCtrl'] or 0) * (-eSteering)
		rollR = 0
	elseif eSteering > 0 then
		rollR = (electrics.values['enSubRollCtrl'] or 0) * (eSteering)
		rollL = 0
	end
	
	electrics.values['subRollCtrlJetL'] = rollL
	electrics.values['subRollCtrlJetR'] = rollR
end

-- Reset what we need to
local function reset()
	print("SubRollCtrl reset called")
	electrics.values['subRollCtrlJetL'] = 0
	electrics.values['subRollCtrlJetR'] = 0
end

-- Initialize everything
local function init(jbeamdata)
	print("SubRollCtrl init called")
	electrics.values['subRollCtrlJetL'] = 0
	electrics.values['subRollCtrlJetR'] = 0
end

-- Public interface
M.init = init
M.reset = reset
M.updateGFX = updateGFX

-- Return the module
return M
