local M = {}
M.type = "auxilliary"
M.relevantDevice = nil
M.defaultOrder = 3
local min = math.min
local max = math.max
local flightMode = "engine"
local flySmoke = 0
local flySmokeType = 6
local flySmokeSpeed = 0
local flySmokeWidth = 1
local flySmokeCount = 10
local flySmokeFPS = 30
local flySmokeTime = 0
local nodec1
local nodec6

local function init()
	electrics.values.super_speed = 0
    electrics.values.super_throttle = 0
	electrics.values.super_thruster = 0
	electrics.values.super_thrustrev = 0
	electrics.values.super_roll = 0
	electrics.values.swingwing = 0
	electrics.values.superelev = 0
	electrics.values.superelev2 = 0
	electrics.values.superclutch = 1
	
	for k, node in pairs (v.data.nodes) do
		if node.name == "tloc"  then throtmod = k elseif
		   node.name == "r2"    then thrustsd = k elseif
		   node.name == "thrr5" then thrustra = k elseif
		   node.name == "thrr0" then thrustrb = k elseif
		   node.name == "thrl5" then thrustla = k elseif
		   node.name == "thrl0" then thrustlb = k elseif
		   node.name == "c1"    then nodec1 = k   elseif
		   node.name == "c6"    then nodec6 = k   end
	end
	
	if thrustsd ~= nil then
	    rocketsnd = obj:createSFXSource("vehicles/supertact/sounds/noise.ogg", 'AudioDefaultLoop3D', '', thrustsd)
	    obj:stopSFX(rocketsnd)
	end
	
	flightMode = "engine"
--	flySmoke = (v.data.variables["$flysmoke"].val or 0)
	flySmokeType = (v.data.variables["$flysmoketype"].val or 0)
	if flySmokeType < 1 or flySmokeType > 127 then flySmokeType = 6 end
	flySmokeSpeed = (v.data.variables["$flysmokespeed"].val or 0)
	if flySmokeSpeed < 0 or flySmokeSpeed > 10 then flySmokeSpeed = 0 end
	flySmokeWidth = (v.data.variables["$flysmokewidth"].val or 0)
	if flySmokeWidth < 1 or flySmokeWidth > 10 then flySmokeWidth = 1 end
	flySmokeCount = (v.data.variables["$flysmokecount"].val or 0)
	if flySmokeCount < 1 or flySmokeCount > 100 then flySmokeCount = 10 end
	flySmokeFPS = (v.data.variables["$flysmokefps"].val or 0)
	if flySmokeFPS < 1 or flySmokeFPS > 120 then flySmokeFPS = 30 end
	flySmokeFPS = 1 / flySmokeFPS
	superRocketFuel = 300000
end	

local function reset()
	init()
end

local function updateGFX(dt)
	
	
	
	if flySmoke == 1 then
		-- addParticleByNodesRelative( nodeId1, nodeid2, velocity, particleType, width, count)
--			obj:addParticleByNodesRelative(nodec6,  nodec1,  0,        6,           1,     10)
		if flySmokeTime >= flySmokeFPS then
			flySmokeTime = 0
			obj:addParticleByNodesRelative(nodec6,  nodec1,  -flySmokeSpeed,        flySmokeType, flySmokeWidth,     flySmokeCount)
		end
		flySmokeTime = flySmokeTime + dt
	end
		
		
	if throtmod ~= nil then
		if flightMode == "rocket" then
			electrics.values.swingwing = 1
		else
			electrics.values.swingwing = 0
		end
--		if electrics.values.throttle > 0.9 then electrics.values.super_thruster = electrics.values.throttle else electrics.values.super_thruster = 0 end
		--if electrics.values.throttle_input > 0.9 then electrics.values.super_thruster = electrics.values.throttle_input else electrics.values.super_thruster = 0 end
		electrics.values.super_thruster = electrics.values.throttle_input
--		electrics.values.super_throttle = electrics.values.throttle
		--electrics.values.super_throttle = electrics.values.throttle_input
		electrics.values.super_throttle = 0
		--electrics.values.superclutch = electrics.values.clutchRatio
		electrics.values.superclutch = 0
		if electrics.values.super_thruster > 0 then
			electrics.values.super_thrustrev = 0
		else
			electrics.values.super_thrustrev = electrics.values.brake_input
		end
		if superRocketFuel > 0 then -- and electrics.values.super_thruster > 0.9 then
			obj:setVolume(rocketsnd, electrics.values.super_thruster * 6 * electrics.values.superThrustLevel / 10000)
			obj:playSFX(rocketsnd)
			for i = 1,4,1 do
--				if i == 1 then obj:addParticleByNodesRelative(thrustra, thrustrb,  -10, 64, 0, electrics.values.throttle * 3) end
				if i == 1 then obj:addParticleByNodesRelative(thrustra, thrustrb,  -10, 64, 0, electrics.values.throttle_input * 3) end
--				if i == 2 then obj:addParticleByNodesRelative(thrustla, thrustlb,  -10, 64, 0, electrics.values.throttle * 3) end
				if i == 2 then obj:addParticleByNodesRelative(thrustla, thrustlb,  -10, 64, 0, electrics.values.throttle_input * 3) end
--				if i == 3 then obj:addParticleByNodesRelative(thrustla, thrustlb, electrics.values.throttle * -30, 44, 0, electrics.values.throttle * 3) end
				if i == 3 then obj:addParticleByNodesRelative(thrustla, thrustlb, electrics.values.throttle_input * -30, 44, 0, electrics.values.throttle_input * 3) end
--				if i == 4 then obj:addParticleByNodesRelative(thrustra, thrustrb, electrics.values.throttle * -30, 44, 0, electrics.values.throttle * 3) end
				if i == 4 then obj:addParticleByNodesRelative(thrustra, thrustrb, electrics.values.throttle_input * -30, 44, 0, electrics.values.throttle_input * 3) end
			end
			else 
			obj:stopSFX(rocketsnd)
		end
		--rocket fuel
		--MODIFIED: Fuel consumption disabled
		-- superRocketFuel = superRocketFuel - (electrics.values.superThrustLevel * electrics.values.super_thruster * dt)
		-- if superRocketFuel <= 0 then electrics.values.super_thruster = 0 superRocketFuel = 0 end
	
	elseif flightMode == "rocket" then
		electrics.values.swingwing = 1	
--		electrics.values.wheelspeed = electrics.values.airspeed
--		electrics.values.super_speed = electrics.values.airspeed
--		electrics.values.super_roll = electrics.values.steering / 140
		if thrustra ~= nil then
			electrics.values.superclutch = 0
--			electrics.values.super_thruster = electrics.values.throttle
			electrics.values.super_thruster = electrics.values.throttle_input
			if electrics.values.super_thruster > 0 then
				electrics.values.super_thrustrev = 0
			else
				electrics.values.super_thrustrev = electrics.values.brake_input
			end
			electrics.values.super_throttle = 0
			electrics.values.rpm = superRocketFuel * 0.02667
			if superRocketFuel > 0 then
				obj:setVolume(rocketsnd, electrics.values.super_thruster * 6 * electrics.values.superThrustLevel / 10000)
				obj:playSFX(rocketsnd)
				for i = 1,4,1 do
--					if i == 1 then obj:addParticleByNodesRelative(thrustra, thrustrb,  -10, 64, 0, electrics.values.throttle * 3) end
					if i == 1 then obj:addParticleByNodesRelative(thrustra, thrustrb,  -10, 64, 0, electrics.values.throttle_input * 3) end
--					if i == 2 then obj:addParticleByNodesRelative(thrustla, thrustlb,  -10, 64, 0, electrics.values.throttle * 3) end
					if i == 2 then obj:addParticleByNodesRelative(thrustla, thrustlb,  -10, 64, 0, electrics.values.throttle_input * 3) end
--					if i == 3 then obj:addParticleByNodesRelative(thrustla, thrustlb, electrics.values.throttle * -30, 44, 0, electrics.values.throttle * 3) end
					if i == 3 then obj:addParticleByNodesRelative(thrustla, thrustlb, electrics.values.throttle_input * -30, 44, 0, electrics.values.throttle_input * 3) end
--					if i == 4 then obj:addParticleByNodesRelative(thrustra, thrustrb, electrics.values.throttle * -30, 44, 0, electrics.values.throttle * 3) end
					if i == 4 then obj:addParticleByNodesRelative(thrustra, thrustrb, electrics.values.throttle_input * -30, 44, 0, electrics.values.throttle_input * 3) end
				end
				else 
				obj:stopSFX(rocketsnd)
			end
			--rocket fuel
			--MODIFIED: Fuel consumption disabled
			-- superRocketFuel = superRocketFuel - (electrics.values.superThrustLevel * electrics.values.super_thruster * dt)
			-- if superRocketFuel <= 0 then electrics.values.super_thruster = 0 superRocketFuel = 0 end
			
		else
--				electrics.values.super_throttle = electrics.values.throttle
			electrics.values.super_throttle = electrics.values.throttle_input
			
			obj:stopSFX(rocketsnd)
			
		end
	else
		electrics.values.swingwing = 0
		electrics.values.super_thruster = 0
		electrics.values.super_thrustrev = 0
		--electrics.values.super_roll = 0
		electrics.values.superelev = 0
		electrics.values.super_throttle = electrics.values.throttle
--		electrics.values.super_throttle = electrics.values.throttle_input
		--electrics.values.super_speed = electrics.values.wheelspeed
		electrics.values.superclutch = electrics.values.clutchRatio
	end	
	
	if electrics.values.swingwing == 1 then
		electrics.values.wheelspeed = electrics.values.airspeed
		electrics.values.super_speed = electrics.values.airspeed
		electrics.values.super_roll = electrics.values.steering / 140
	else
		electrics.values.super_speed = electrics.values.wheelspeed
		electrics.values.super_roll = 0
	end

end

local function toggleFlightMode()
    if flightMode == "rocket" then
        flightMode = "engine"
		obj:stopSFX(rocketsnd)
    else
        flightMode = "rocket"
    end
    if thrustra ~= nil then gui.message("Throttle mode: " .. flightMode, 10, "supertact.Flightmode") end
end

local function toggleFlySmoke()
	if flySmoke == 0 then
		flySmoke = 1
		flySmokeTime = 0
		--print("Fly smoke on")
	else
		flySmoke = 0
	end
end

M.onInit = init
M.onReset = reset
M.updateGFX = updateGFX
M.toggleFlightMode = toggleFlightMode
M.toggleFlySmoke = toggleFlySmoke

return M